#include "HdecayWrap.h"

using namespace std;

void HdecayCalc(void){
  double dummy;
  hdecaycallplain_(dummy);
}

void HdecayCalc2HDM(std::map<std::string,double> & HdecayA,std::map<std::string,double> & HdecayHlight,std::map<std::string,double> & HdecayHheavy,std::map<std::string,double> & HdecayHcharged){

  double ABRB_out,ABRL_out,ABRM_out,ABRS_out,ABRC_out,ABRT_out,ABRG_out,ABRGA_out, ABRZGA_out,ABRZ_out,AWDTH_out,HLBRB_out,HLBRL_out,HLBRM_out,HLBRS_out,HLBRC_out,HLBRT_out,HLBRG_out,HLBRGA_out,HLBRZGA_out,HLBRW_out,HLBRZ_out,HLBRA_out,HLBRAZ_out,HLBRHW_out,HLWDTH_out,HHBRB_out,HHBRL_out,HHBRM_out,HHBRS_out,HHBRC_out,HHBRT_out,HHBRG_out,HHBRGA_out,HHBRZGA_out,HHBRW_out,HHBRZ_out,HHBRH_out,HHBRA_out,HHBRAZ_out,HHBRHW_out,HHWDTH_out,HCBRB_out,HCBRL_out,HCBRM_out,HCBRBU_out,HCBRS_out,HCBRC_out,HCBRT_out,HCBRW_out,HCBRA_out,HCWDTH_out,hcbrcd_out,hcbrts_out,hcbrtd_out,hcbrwhh_out,hhbrchch_out,hlbrchch_out,abrhhaz_out,abrhawphm_out;

  hdecaycall_(ABRB_out,ABRL_out,ABRM_out,ABRS_out,ABRC_out,ABRT_out,ABRG_out,ABRGA_out, ABRZGA_out,ABRZ_out,AWDTH_out,HLBRB_out,HLBRL_out,HLBRM_out,HLBRS_out,HLBRC_out,HLBRT_out,HLBRG_out,HLBRGA_out,HLBRZGA_out,HLBRW_out,HLBRZ_out,HLBRA_out,HLBRAZ_out,HLBRHW_out,HLWDTH_out,HHBRB_out,HHBRL_out,HHBRM_out,HHBRS_out,HHBRC_out,HHBRT_out,HHBRG_out,HHBRGA_out,HHBRZGA_out,HHBRW_out,HHBRZ_out,HHBRH_out,HHBRA_out,HHBRAZ_out,HHBRHW_out,HHWDTH_out,HCBRB_out,HCBRL_out,HCBRM_out,HCBRBU_out,HCBRS_out,HCBRC_out,HCBRT_out,HCBRW_out,HCBRA_out,HCWDTH_out,hcbrcd_out,hcbrts_out,hcbrtd_out,hcbrwhh_out,hhbrchch_out,hlbrchch_out,abrhhaz_out,abrhawphm_out);

  HdecayA["BR(A -> b bbar)"]=ABRB_out;
  HdecayA["BR(A -> tau+ tau-)"]=ABRL_out;
  HdecayA["BR(A -> mu+ mu-)"]=ABRM_out;
  HdecayA["BR(A -> s sbar)"]=ABRS_out;
  HdecayA["BR(A -> c cbar)"]=ABRC_out;
  HdecayA["BR(A -> t tbar)"]=ABRT_out;
  HdecayA["BR(A -> g g)"]=ABRG_out;
  HdecayA["BR(A -> gamma gamma)"]=ABRGA_out;
  HdecayA["BR(A -> Z gamma)"]=ABRZGA_out;
  HdecayA["BR(A -> Z h)"]=ABRZ_out;
  HdecayA["BR(A -> A Z)"]=abrhhaz_out; 
  HdecayA["BR(A -> A W+ H-)"]=abrhawphm_out; 
  HdecayA["Width"]=AWDTH_out;

  HdecayHlight["BR(h -> b bbar)"]=HLBRB_out;
  HdecayHlight["BR(h -> tau+ tau-)"]=HLBRL_out;
  HdecayHlight["BR(h -> mu+ mu-)"]=HLBRM_out;
  HdecayHlight["BR(h -> s sbar)"]=HLBRS_out;
  HdecayHlight["BR(h -> c cbar)"]=HLBRC_out;
  HdecayHlight["BR(h -> t tbar)"]=HLBRT_out;
  HdecayHlight["BR(h -> g g)"]=HLBRG_out;
  HdecayHlight["BR(h -> gamma gamma)"]=HLBRGA_out;
  HdecayHlight["BR(h -> Z gamma)"]=HLBRZGA_out;
  HdecayHlight["BR(h -> W+ W-)"]=HLBRW_out;
  HdecayHlight["BR(h -> Z Z)"]=HLBRZ_out;
  HdecayHlight["BR(h -> A A)"]=HLBRA_out;
  HdecayHlight["BR(h -> Z A)"]=HLBRAZ_out;
  HdecayHlight["BR(h -> H+ H-)"]=hlbrchch_out; 
  HdecayHlight["BR(h -> W+ H-)+BR(h -> W- H+)"]=HLBRHW_out;

  HdecayHlight["Width"]=HLWDTH_out;

  HdecayHheavy["BR(H -> b bbar)"]=HHBRB_out;
  HdecayHheavy["BR(H -> tau+ tau-)"]=HHBRL_out;
  HdecayHheavy["BR(H -> mu+ mu-)"]=HHBRM_out;
  HdecayHheavy["BR(H -> s sbar)"]=HHBRS_out;
  HdecayHheavy["BR(H -> c cbar)"]=HHBRC_out;
  HdecayHheavy["BR(H -> t tbar)"]=HHBRT_out;
  HdecayHheavy["BR(H -> g g)"]=HHBRG_out;
  HdecayHheavy["BR(H -> gamma gamma)"]=HHBRGA_out;
  HdecayHheavy["BR(H -> Z gamma)"]=HHBRZGA_out;
  HdecayHheavy["BR(H -> W+ W-)"]=HHBRW_out;
  HdecayHheavy["BR(H -> Z Z)"]=HHBRZ_out;
  HdecayHheavy["BR(H -> h h)"]=HHBRH_out;
  HdecayHheavy["BR(H -> A A)"]=HHBRA_out;
  HdecayHheavy["BR(H -> Z A)"]=HHBRAZ_out;
  HdecayHheavy["BR(H -> W+ H-)+BR(H -> W- H+)"]=HHBRHW_out;
  HdecayHheavy["BR(H -> H+ H-)"]=hhbrchch_out; 

  HdecayHheavy["Width"]=HHWDTH_out;

  HdecayHcharged["BR(H+ -> c bbar)"]=HCBRB_out;
  HdecayHcharged["BR(H+ -> tau+ nu_tau)"]=HCBRL_out;
  HdecayHcharged["BR(H+ -> mu+ nu_mu)"]=HCBRM_out;
  HdecayHcharged["BR(H+ -> u bbar)"]=HCBRBU_out;
  HdecayHcharged["BR(H+ -> u sbar)"]=HCBRS_out;
  HdecayHcharged["BR(H+ -> c dbar)"]=hcbrcd_out; 
  HdecayHcharged["BR(H+ -> c sbar)"]=HCBRC_out;
  HdecayHcharged["BR(H+ -> t bbar)"]=HCBRT_out;
  HdecayHcharged["BR(H+ -> t sbar)"]=hcbrts_out; 
  HdecayHcharged["BR(H+ -> t dbar)"]=hcbrtd_out; 
  HdecayHcharged["BR(H+ -> W+ h)"]=HCBRW_out;
  HdecayHcharged["BR(H+ -> W+ H)"]=hcbrwhh_out; 
  HdecayHcharged["BR(H+ -> W+ A)"]=HCBRA_out;

  HdecayHcharged["Width"]=HCWDTH_out;

}

void CreateInputFileHdecay2HDM(int Type, double tanbeta,double alpha, double mHlight,double mHheavy, double mA, double mCharged,double m12sq){
  ofstream outfile ; // ofstream output file object to write file;
  outfile.open("hdecay.in"); //open file named "tempsuperiso.lha" in the current directory

  outfile<<"SLHAIN   = 0"<<endl;
  outfile<<"SLHAOUT  = 0"<<endl;
  outfile<<"COUPVAR  = 0"<<endl;
  outfile<<"HIGGS    = 5"<<endl;
  outfile<<"SM4      = 0"<<endl;
  outfile<<"FERMPHOB = 0"<<endl;
  outfile<<"2HDM     = 1"<<endl;
  outfile<<"MODEL    = 1"<<endl;
  outfile<<fixed<<setprecision(3);
  int exp=log10(tanbeta);
  outfile<<"TGBET    = "<<tanbeta/pow(10,exp)<<"D"<<exp<<endl;
  outfile<<"MABEG    = 125.D0"<<endl;
  outfile<<"MAEND    = 1000.D0"<<endl;
  outfile<<"NMA      = 1"<<endl;
  outfile<<"ALS(MZ)  = 0.119D0"<<endl;
  outfile<<"MSBAR(2) = 0.100D0"<<endl;
  outfile<<"MC       = 1.42D0"<<endl;
  outfile<<"MB       = 4.75D0"<<endl;
  outfile<<"MT       = 172.5D0"<<endl;
  outfile<<"MTAU     = 1.77684D0"<<endl;
  outfile<<"MMUON    = 0.105658367D0"<<endl;
  outfile<<"1/ALPHA  = 137.0359997D0"<<endl;
  outfile<<"GF       = 1.16637D-5"<<endl;
  outfile<<"GAMW     = 2.08856D0"<<endl;
  outfile<<"GAMZ     = 2.49581D0"<<endl;
  outfile<<"MZ       = 91.15349D0"<<endl;
  outfile<<"MW       = 80.36951D0"<<endl;
  outfile<<"VTB      = 0.9991D0"<<endl;
  outfile<<"VTS      = 0.0404D0"<<endl;
  outfile<<"VTD      = 0.00867D0"<<endl;
  outfile<<"VCB      = 0.0412D0"<<endl;
  outfile<<"VCS      = 0.97344D0"<<endl;
  outfile<<"VCD      = 0.22520D0"<<endl;
  outfile<<"VUB      = 0.00351D0"<<endl;
  outfile<<"VUS      = 0.22534D0"<<endl;
  outfile<<"VUD      = 0.97427D0"<<endl;
  outfile<<"********************* 4TH GENERATION *************************************"<<endl;
  outfile<<"  SCENARIO FOR ELW. CORRECTIONS TO H -> GG (EVERYTHING IN GEV):"<<endl;
  outfile<<"  GG_ELW = 1: MTP = 500    MBP = 450    MNUP = 375    MEP = 450"<<endl;
  outfile<<"  GG_ELW = 2: MBP = MNUP = MEP = 600    MTP = MBP+50*(1+LOG(M_H/115)/5)"<<endl<<endl;

  outfile<<"GG_ELW   = 1"<<endl;
  outfile<<"MTP      = 500.D0"<<endl;
  outfile<<"MBP      = 450.D0"<<endl;
  outfile<<"MNUP     = 375.D0"<<endl;
  outfile<<"MEP      = 450.D0"<<endl;
  outfile<<"************************** 2 Higgs Doublet Model *************************"<<endl;
  outfile<<"  TYPE: 1 (I), 2 (II)"<<endl<<endl;

  outfile<<"TYPE     = "<<fixed<<Type<<setprecision(3)<<endl;
  exp=log10(tanbeta);
  outfile<<"TGBET2HDM= "<<tanbeta/pow(10,exp)<<"D"<<exp<<endl;
  exp=log10(abs(alpha));
  outfile<<"ALPHA_H  = "<<alpha/pow(10,exp)<<"D"<<exp<<endl;
  exp=log10(mHlight);
  outfile<<"MHL      = "<<mHlight/pow(10,exp)<<"D"<<exp<<endl;
  exp=log10(mHheavy);
  outfile<<"MHH      = "<<mHheavy/pow(10,exp)<<"D"<<exp<<endl;
  exp=log10(mA);
  outfile<<"MHA      = "<<mA/pow(10,exp)<<"D"<<exp<<endl;
  exp=log10(mCharged);
  outfile<<"MH+-     = "<<mCharged/pow(10,exp)<<"D"<<exp<<endl;
  exp=log10(m12sq);
  outfile<<"M_12^2   = "<<m12sq/pow(10,exp)<<"D"<<exp<<endl;
  outfile<<"**************************************************************************"<<endl;
  outfile<<"SUSYSCALE= 1000.D0"<<endl;
  outfile<<"MU       = 1000.D0"<<endl;
  outfile<<"M2       = 1000.D0"<<endl;
  outfile<<"MGLUINO  = 1000.D0"<<endl;
  outfile<<"MSL1     = 1000.D0"<<endl;
  outfile<<"MER1     = 1000.D0"<<endl;
  outfile<<"MQL1     = 1000.D0"<<endl;
  outfile<<"MUR1     = 1000.D0"<<endl;
  outfile<<"MDR1     = 1000.D0"<<endl;
  outfile<<"MSL      = 1000.D0"<<endl;
  outfile<<"MER      = 1000.D0"<<endl;
  outfile<<"MSQ      = 1000.D0"<<endl;
  outfile<<"MUR      = 1000.D0"<<endl;
  outfile<<"MDR      = 1000.D0"<<endl;
  outfile<<"AL       = 1000.D0"<<endl;
  outfile<<"AU       = 1000.D0"<<endl;
  outfile<<"AD       = 1000.D0"<<endl;
  outfile<<"NNLO (M) = 0"<<endl;
  outfile<<"ON-SHELL = 0"<<endl;
  outfile<<"ON-SH-WZ = 0"<<endl;
  outfile<<"IPOLE    = 0"<<endl;
  outfile<<"OFF-SUSY = 0"<<endl;
  outfile<<"INDIDEC  = 0"<<endl;
  outfile<<"NF-GG    = 5"<<endl;
  outfile<<"IGOLD    = 0"<<endl;
  outfile<<"MPLANCK  = 2.4D18"<<endl;
  outfile<<"MGOLD    = 1.D-13"<<endl;
  outfile<<"******************* VARIATION OF HIGGS COUPLINGS *************************"<<endl;
  outfile<<"ELWK     = 0"<<endl;
  outfile<<"CW       = 1.D0"<<endl;
  outfile<<"CZ       = 1.D0"<<endl;
  outfile<<"Ctau     = 1.D0"<<endl;
  outfile<<"Cmu      = 1.D0"<<endl;
  outfile<<"Ct       = 1.D0"<<endl;
  outfile<<"Cb       = 1.D0"<<endl;
  outfile<<"Cc       = 1.D0"<<endl;
  outfile<<"Cs       = 1.D0"<<endl;
  outfile<<"Cgaga    = 0.D0"<<endl;
  outfile<<"Cgg      = 0.D0"<<endl;
  outfile<<"CZga     = 0.D0"<<endl;
  
  outfile.close();

}
